<template>
    <div class="col-xs-12 col-md-6">
        <h1 v-if="imports">Edit import</h1>
        <h1 v-else>Add import</h1>

        <div class="form-group">
            <label>Name</label>
            <input type="text" v-model="imports.name" class="form-control"/>
        </div>
        <div class="form-group">
            <label>Load file from:</label>
            <select v-model="imports.type" @change="resetValues()">
                <option value="url">URL</option>
                <option value="ftp">FTP</option>
                <option value="upload">Upload</option>
            </select>
        </div>

        <div class="form-group" v-if="imports.type === 'url'">
            <label>URL of the file</label>
            <input type="text" v-model="imports.values.url_address" class="form-control"/>
        </div>

        <div v-if="imports.type === 'ftp'">
            <div class="form-group">
                <label>FTP address</label>
                <input type="text" v-model="imports.values.ftp_address" class="form-control"/>
            </div>
            <div class="form-group">
                <label>FTP login</label>
                <input type="text" v-model="imports.values.ftp_login" class="form-control"/>
            </div>
            <div class="form-group">
                <label>FTP password</label>
                <input type="text" v-model="imports.values.ftp_password" class="form-control"/>
            </div>
            <div class="form-group">
                <label>File path</label>
                <input type="text" v-model="imports.values.ftp_path" class="form-control"/>
            </div>
        </div>

        <div class="form-group">
            <label>File type:</label>
            <select v-model="imports.file_type">
                <option value="csv">CSV</option>
                <option value="json">JSON</option>
                <option value="xml">XML</option>
            </select>
        </div>
        <div class="form-group">
            <label>Update type:</label>
            <select v-model="imports.update_type">
                <option v-for="type in update_types" v-bind:value="type.code">{{type.name}}</option>
            </select>
        </div>
        <div class="form-group">
            <label>Warehouses:</label>
            <select v-model="imports.warehouse">
                <option value="">Please select warehouse</option>
                <option v-for="warehouse in warehouses" v-bind:value="warehouse._id">{{warehouse.name}}</option>
            </select>
        </div>
        <div class="form-group">
            <label>Suppliers:</label>
            <select v-model="imports.supplier">
                <option value="">Please select supplier</option>
                <option v-for="supplier in suppliers" v-bind:value="supplier._id">{{supplier.name}}</option>
            </select>
        </div>
        <div class="form-group">
            <label>Currency:</label>
            <select v-model="imports.currency">
                <option value="eur">EUR</option>
                <option value="usd">USD</option>
                <option value="gbp">GBP</option>
            </select>
        </div>
        <div class="form-group">
            <label>Set limit in percents on products quantity which will be taken from supplier's list</label>
            <input type="number" v-model="imports.qty_limit" class="form-control" min="1" max="99"/>
        </div>
        <div class="form-group">
            <label>Set price modifier in percents for product's cost</label>
            <input type="number" v-model="imports.price_modifier" class="form-control" min="1"/>
        </div>
        <div class="form-group">
            <label>Status</label>
            <input type="checkbox" v-model="imports.status" :checked="false" class="form-control"/>
        </div>
        <div class="col-sm-12">
            <span class="btn btn-default custom-attrs-form__save" @click="saveImport()">Save</span>
            <span class="btn btn-danger repeater__button--delete" @click="deleteImport()">Delete</span>
            <span class="btn btn-danger repeater__button--delete" @click="getCsvData()">Get CSV data</span>
        </div>
    </div>
</template>
<style>
</style>
<script>
    export default{
        data: function () {
            return {
                imports: {
                    values: {}
                },
                update_types: [{}],
                warehouses: [],
                suppliers: []
            }
        },
        route: {
            data: function (transition) {
                var id = this.$route.params.id;
                if (id != undefined) {
                    return this.$http.get('/api/v1/imports/import/' + id).then(function (res) {
//						console.log(res);
                        return {
                            imports: res.data
                        }
                    });
                }
            }
        },
        ready: function () {
            this.getUpdateTypes().then(function (res) {
                this.update_types = res;
            });
            this.getWarehouses().then(function (res) {
                this.warehouses = res;
            });
            this.getSuppliers().then(function (res) {
                this.suppliers = res;
            });
        },
        methods: {
            deleteImport: function () {
                if (this.imports.id) {
                    this.$http.delete('/api/v1/imports/delete/' + this.imports.id).then(function (res) {
                        console.log(res.data);
                    });
                }
            },
            saveImport: function () {
                if (this.imports.id) {
                    this.$http.put('/api/v1/imports/update/' + this.imports.id, this.imports).then(function (res) {
                        console.log(res.data);
                        if (res.data.error) {
                            alert(res.data.error)
                        }
                    })
                } else {
                    this.$http.post('/api/v1/imports/create', this.imports).then(function (res) {
                        console.log(res.data);
                        if (res.data.error) {
                            alert(res.data.error)
                        }
                    })
                }
            },
            getUpdateTypes: function () {
                return this.$http.get('/api/v1/settings/import_update_types').then(function (res) {
                    return res.data.data
                })
            },
            getWarehouses: function () {
                return this.$http.get('/api/v1/warehouses/fields/id+name').then(function (res) {
                    return res.data;
                })
            },
            getSuppliers: function () {
                return this.$http.get('/api/v1/suppliers/fields/id+name').then(function (res) {
                    return res.data;
                })
            },
            resetValues: function () {
                return this.imports.values = {};
            },
            getCsvData: function () {
                var sets = {
                    file: this.imports.values.url_address,
                    offset: 0,
//					separator: "",
                    headers: true
                };
                console.log(sets);

                return this.$http.get('/api/v1/imports/csvData', {params: sets}).then(function (res) {
                    console.log(res);
//					return res.data.data
                })
            }
        }
    }


</script>
